﻿Imports Infragistics.UltraChart.Resources.Appearance
Imports Infragistics.UltraChart.Core.Layers
Imports Infragistics.UltraChart.Shared.Styles

Partial Public Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim ds = Me.GetDataIMC

        UltraChart1.DataSource = ds
        UltraChart1.DataBind()
        UltraChart1.ChartType = ChartType.Composite
        UltraChart1.Width = 1024
        UltraChart1.Height = 600
        'UltraChart1.TitleTop.Text = "titulo"
        UltraChart1.EnableCrossHair = True

        Dim myChartArea As ChartArea = New ChartArea()
        UltraChart1.CompositeChart.ChartAreas.Add(myChartArea)

        Dim myX As AxisItem = New AxisItem()
        myX.OrientationType = AxisNumber.X_Axis
        myX.DataType = AxisDataType.String
        myX.Labels.ItemFormatString = "<ITEM_LABEL>"
        myX.SetLabelAxisType = SetLabelAxisType.ContinuousData
        myX.MajorGridLines.Visible = True

        Dim myY As AxisItem = New AxisItem()

        Dim myYSecondary As AxisItem = New AxisItem()

        Me.axisIMC(myY, myYSecondary)

        myChartArea.Axes.Add(myX)
        myChartArea.Axes.Add(myY)
        myChartArea.Axes.Add(myYSecondary)

        Dim mylayer As ChartLayerAppearance = New ChartLayerAppearance()
        mylayer.ChartType = ChartType.SplineChart
        mylayer.ChartArea = myChartArea
        mylayer.AxisX = myX
        mylayer.AxisY = myY
        mylayer.AxisY2 = myYSecondary
        Me.layerIMC(ds, mylayer)

        Dim SPlinechartappearance As New SplineChartAppearance
        Dim line As New LineAppearance
        line.Thickness = 3
        line.LineStyle.DrawStyle = LineDrawStyle.Solid
        line.IconAppearance.Icon = SymbolIcon.None
        line.SplineTension = 0.5

        SPlinechartappearance.LineAppearances.Add(line)

        mylayer.ChartTypeAppearance = SPlinechartappearance

        Me.UltraChart1.CompositeChart.ChartLayers.Add(mylayer)
    End Sub
    Private Sub axisIMC(ByRef myY As AxisItem, ByRef myYSecondary As AxisItem)
        myY.OrientationType = AxisNumber.Y_Axis
        myY.DataType = AxisDataType.Numeric
        myY.Labels.ItemFormatString = "<DATA_VALUE:0>"
        myY.Labels.Orientation = TextOrientation.Horizontal
        myY.RangeType = AxisRangeType.Custom
        myY.RangeMin = 9
        myY.RangeMax = 22
        myY.TickmarkStyle = AxisTickStyle.DataInterval
        myY.TickmarkInterval = 1
        myY.MajorGridLines.Visible = True

        'add axis Y2
        myYSecondary.OrientationType = AxisNumber.Y2_Axis
        'myYSecondary = myY.Clone
        myYSecondary.DataType = AxisDataType.Numeric
        myYSecondary.Labels.ItemFormatString = "<DATA_VALUE:0>"
        myYSecondary.Labels.Orientation = TextOrientation.Horizontal
        myYSecondary.RangeType = AxisRangeType.Custom
        myYSecondary.RangeMin = 9
        myYSecondary.RangeMax = 22
        myYSecondary.TickmarkStyle = AxisTickStyle.DataInterval
        myYSecondary.TickmarkInterval = 1
        myYSecondary.MajorGridLines.Visible = True
    End Sub
    Private Sub layerIMC(ByVal ds As DataSet, ByRef itemLayer As ChartLayerAppearance)
        For i As Integer = 1 To ds.Tables(0).Columns.Count - 1

            If ds.Tables(0).Columns(i).ColumnName = "P3" Or _
            ds.Tables(0).Columns(i).ColumnName = "P15" Or _
            ds.Tables(0).Columns(i).ColumnName = "P50" Or _
            ds.Tables(0).Columns(i).ColumnName = "P85" Or _
            ds.Tables(0).Columns(i).ColumnName = "P97" Then
                'add series to Series collection.
                Dim myseries As NumericSeries = New NumericSeries()
                myseries.Label = ds.Tables(0).Columns(i).ToString()
                'data bound
                myseries.Data.DataSource = ds.Tables(0)
                myseries.Data.LabelColumn = ds.Tables(0).Columns(0).ToString()

                myseries.Data.ValueColumn = ds.Tables(0).Columns(i).ToString()
                UltraChart1.CompositeChart.Series.Add(myseries)

                itemLayer.Series.Add(myseries)

            End If

        Next
    End Sub


    Private Function GetDataIMC() As DataSet
        Dim mydata As New DataTable()
        mydata.Columns.Add("Mes", GetType(Integer))
        mydata.Columns.Add("P1", GetType(Double))
        mydata.Columns.Add("P3", GetType(Double))
        mydata.Columns.Add("P5", GetType(Double))
        mydata.Columns.Add("P15", GetType(Double))
        mydata.Columns.Add("P25", GetType(Double))
        mydata.Columns.Add("P50", GetType(Double))
        mydata.Columns.Add("P75", GetType(Double))
        mydata.Columns.Add("P85", GetType(Double))
        mydata.Columns.Add("P95", GetType(Double))
        mydata.Columns.Add("P97", GetType(Double))
        mydata.Columns.Add("P99", GetType(Double))
        mydata.Rows.Add(New [Object]() {0, 10.8, 11.2, 11.5, 12.1, 12.5, 13.3, 14.2, 14.7, 15.5, 15.9, 16.6})
        mydata.Rows.Add(New [Object]() {1, 11.6, 12.1, 12.4, 13.2, 13.6, 14.6, 15.5, 16.1, 17.0, 17.3, 18.0})
        mydata.Rows.Add(New [Object]() {2, 12.6, 13.2, 13.5, 14.3, 14.8, 15.8, 16.8, 17.4, 18.4, 18.8, 19.5})
        mydata.Rows.Add(New [Object]() {3, 13.2, 13.7, 14.0, 14.9, 15.4, 16.4, 17.4, 18.0, 19.0, 19.4, 20.3})
        mydata.Rows.Add(New [Object]() {4, 13.5, 14.0, 14.3, 15.2, 15.7, 16.7, 17.7, 18.3, 19.4, 19.8, 20.6})
        mydata.Rows.Add(New [Object]() {5, 13.7, 14.2, 14.5, 15.3, 15.8, 16.8, 17.9, 18.5, 19.6, 20.0, 20.8})
        '... more information
        Dim ds As New DataSet
        ds.Tables.Add(mydata)

        Return ds
    End Function

End Class